Package com.documentum.fc.client.search

# Interface IDfSimpleAttrExpression

All Superinterfaces:
  `IDfAttrExpression`, `IDfExpression`

All Known Subinterfaces:
  `IDfRelativeDateExpression`

public interface IDfSimpleAttrExpression extends IDfAttrExpression
Defines a simple search expression on an attribute. (For example, contains, equals, begins with, is null....)

See Also:
  - `IDfQueryBuilder.getRootExpressionSet()`
  - `IDfExpressionSet.addSimpleAttrExpression(String, int, int, boolean, boolean, String)`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `SEARCH_OP_BEGINS_WITH`
  Search operation code: begins with.
  `static final int`
  `SEARCH_OP_CONTAINS`
  Search operation code: contains.
  `static final int`
  `SEARCH_OP_DOES_NOT_CONTAIN`
  Search operation code: does not contain.
  `static final int`
  `SEARCH_OP_ENDS_WITH`
  Search operation code: ends with.
  `static final int`
  `SEARCH_OP_EQUAL`
  Search operation code: equal.
  `static final int`
  `SEARCH_OP_GREATER_EQUAL`
  Search operation code: greater than or equal.
  `static final int`
  `SEARCH_OP_GREATER_THAN`
  Search operation code: greater than.
  `static final int`
  `SEARCH_OP_IS_NOT_NULL`
  Search operation code: is not null.
  `static final int`
  `SEARCH_OP_IS_NULL`
  Search operation code: is null.
  `static final int`
  `SEARCH_OP_LESS_EQUAL`
  Search operation code: less than or equal.
  `static final int`
  `SEARCH_OP_LESS_THAN`
  Search operation code: less than.
  `static final int`
  `SEARCH_OP_NOT_EQUAL`
  Search operation code: not equal.

  ### Fields inherited from interface com.documentum.fc.client.search.IDfAttrExpression

  `SEARCH_OP_UNDEFINED`

  ### Fields inherited from interface com.documentum.fc.client.search.IDfExpression

  `DATE_FORMAT_DEFAULT, EXPR_TYPE_FULLTEXT, EXPR_TYPE_MLT, EXPR_TYPE_RELATIVE_DATE, EXPR_TYPE_SET, EXPR_TYPE_SIMPLE_ATTR, EXPR_TYPE_UNDEFINED, EXPR_TYPE_VALUE_LIST_ATTR, EXPR_TYPE_VALUE_RANGE_ATTR`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Float`
  `getFuzzySearchSimilarity()`
  Indicates the similarity threshold used with the fuzzy search option
  `String`
  `getThesaurusLibrary()`
  Indicates the thesaurus URI that is used with the thesaurus option
  `String`
  `getValue()`
  Gets the expected value of the search operation.
  `Boolean`
  `isExactMatchEnabled()`
  Indicates if an equals or a not_equals constraint must be exact match constraint.
  `Boolean`
  `isFuzzySearchEnabled()`
  Indicates if fuzzy search will be used to validate this constraint
  `Boolean`
  `isThesaurusSearchEnabled()`
  Indicates if the thesaurus option will be used to validate this constraint
  `void`
  `setExactMatchEnabled(Boolean exactMatchEnabled)`
  To evaluate an EQUALS or NOT_EQUALS constraint, an exact match can be done : no stemming, no stop words removal, no thesaurus search or wildcards.
  `void`
  `setFuzzySearchEnabled(Boolean fuzzySearchEnabled)`
  Fuzzy Search is an option that can be used only with xPlore 1.1 backend and with XQuery.
  `void`
  `setFuzzySearchSimilarity(Float similarity)`
  Set the similarity value for the fuzzy search option This flag overrides the flag 'default_fuzzy_search_similarity' in the dm_ftengine_config object
  `void`
  `setThesaurusLibrary(String thesaurusLibrary)`
  Set the thesaurus library URI for the thesaurus option This flag overrides the flag 'use_thesaurus_library' in the dm_ftengine_config object
  `void`
  `setThesaurusSearchEnabled(Boolean thesaurusSearchEnabled)`
  Thesaurus Search is an option that can be used only with xPlore 1.2 backend and with XQuery.

  ### Methods inherited from interface com.documentum.fc.client.search.IDfAttrExpression

  `getAttrName, getSearchOperation, getSearchOperationCode, getValueDataType, isCaseSensitive, isRepeated`

  ### Methods inherited from interface com.documentum.fc.client.search.IDfExpression

  `acceptVisitor, getDateFormat, getExpressionType, setDateFormat`

- ## Field Details

  - ### SEARCH_OP_EQUAL

    static final int SEARCH_OP_EQUAL
    Search operation code: equal.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_NOT_EQUAL

    static final int SEARCH_OP_NOT_EQUAL
    Search operation code: not equal.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_GREATER_THAN

    static final int SEARCH_OP_GREATER_THAN
    Search operation code: greater than.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_LESS_THAN

    static final int SEARCH_OP_LESS_THAN
    Search operation code: less than.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_GREATER_EQUAL

    static final int SEARCH_OP_GREATER_EQUAL
    Search operation code: greater than or equal.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_LESS_EQUAL

    static final int SEARCH_OP_LESS_EQUAL
    Search operation code: less than or equal.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_BEGINS_WITH

    static final int SEARCH_OP_BEGINS_WITH
    Search operation code: begins with.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_CONTAINS

    static final int SEARCH_OP_CONTAINS
    Search operation code: contains.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_DOES_NOT_CONTAIN

    static final int SEARCH_OP_DOES_NOT_CONTAIN
    Search operation code: does not contain.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_ENDS_WITH

    static final int SEARCH_OP_ENDS_WITH
    Search operation code: ends with.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_IS_NULL

    static final int SEARCH_OP_IS_NULL
    Search operation code: is null.
    See Also:
      - Constant Field Values

  - ### SEARCH_OP_IS_NOT_NULL

    static final int SEARCH_OP_IS_NOT_NULL
    Search operation code: is not null.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getValue

    String getValue()
    Gets the expected value of the search operation.

    When the query runs against xPlore, one can use wildcards in the value. The wildcards character are * (to match several characters) and ? (to match one character or none)
    Returns:
      The expected value of the search operation, or `null` if none.

  - ### isFuzzySearchEnabled

    Boolean isFuzzySearchEnabled()
    Indicates if fuzzy search will be used to validate this constraint
    Returns:

  - ### getFuzzySearchSimilarity

    Float getFuzzySearchSimilarity()
    Indicates the similarity threshold used with the fuzzy search option
    Returns:
      the similarity value between 0 and 1.

  - ### setFuzzySearchEnabled

    void setFuzzySearchEnabled(Boolean fuzzySearchEnabled)
    Fuzzy Search is an option that can be used only with xPlore 1.1 backend and with XQuery. In this case, this flag enables/disables fuzzy search. Fuzzy search will be used only with the operators SEARCH_OP_DOES_NOT_CONTAIN, SEARCH_OP_CONTAINS, SEARCH_OP_EQUAL

    e.g. when searching for "roam", the search will find terms like "foam" and "roams".

    Parameters:
      `fuzzySearchEnabled` -

  - ### setFuzzySearchSimilarity

    void setFuzzySearchSimilarity(Float similarity)
    Set the similarity value for the fuzzy search option This flag overrides the flag 'default_fuzzy_search_similarity' in the dm_ftengine_config object
    Parameters:
      `similarity` - value between 0 and 1.

  - ### isThesaurusSearchEnabled

    Boolean isThesaurusSearchEnabled()
    Indicates if the thesaurus option will be used to validate this constraint
    Returns:

  - ### getThesaurusLibrary

    String getThesaurusLibrary()
    Indicates the thesaurus URI that is used with the thesaurus option
    Returns:

  - ### setThesaurusSearchEnabled

    void setThesaurusSearchEnabled(Boolean thesaurusSearchEnabled)
    Thesaurus Search is an option that can be used only with xPlore 1.2 backend and with XQuery. In this case, this flag enables/disables thesaurus search. Thesaurus search will be used only with the operators SEARCH_OP_CONTAINS, SEARCH_OP_EQUAL

    e.g. the query terms will be expanded according to the terms declared in a thesaurus.

    Parameters:
      `thesaurusSearchEnabled` -

  - ### setThesaurusLibrary

    void setThesaurusLibrary(String thesaurusLibrary)
    Set the thesaurus library URI for the thesaurus option This flag overrides the flag 'use_thesaurus_library' in the dm_ftengine_config object
    Parameters:
      `thesaurusLibrary` - thesaurus URI.

  - ### isExactMatchEnabled

    Boolean isExactMatchEnabled()
    Indicates if an equals or a not_equals constraint must be exact match constraint.
    Returns:

  - ### setExactMatchEnabled

    void setExactMatchEnabled(Boolean exactMatchEnabled)
    To evaluate an EQUALS or NOT_EQUALS constraint, an exact match can be done : no stemming, no stop words removal, no thesaurus search or wildcards. Such an evaluation is not the default one but can be enabled by setting this flag and is more optimized.
    Parameters:
      `exactMatchEnabled` -